/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 718:  /* delay_cycles_2x_plus2_si */
    case 717:  /* delay_cycles_2x_plus1_hi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 716:  /* delay_cycles_end */
    case 715:  /* delay_cycles_start */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      break;

    case 713:  /* pruloopsi */
    case 712:  /* pruloophi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      break;

    case 711:  /* doloop_end_internalsi */
    case 710:  /* doloop_end_internalhi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XVECEXP (pat, 0, 2), 0, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 3), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[1] = 0;
      break;

    case 707:  /* cbranch_qbbx_const_nedi */
    case 706:  /* cbranch_qbbx_const_eqdi */
    case 705:  /* cbranch_qbbx_const_nesi */
    case 704:  /* cbranch_qbbx_const_eqsi */
    case 703:  /* cbranch_qbbx_const_nehi */
    case 702:  /* cbranch_qbbx_const_eqhi */
    case 701:  /* cbranch_qbbx_nesisisi4 */
    case 700:  /* cbranch_qbbx_eqsisisi4 */
    case 699:  /* cbranch_qbbx_nesihisi4 */
    case 698:  /* cbranch_qbbx_eqsihisi4 */
    case 697:  /* cbranch_qbbx_nesiqisi4 */
    case 696:  /* cbranch_qbbx_eqsiqisi4 */
    case 695:  /* cbranch_qbbx_nehisisi4 */
    case 694:  /* cbranch_qbbx_eqhisisi4 */
    case 693:  /* cbranch_qbbx_nehihisi4 */
    case 692:  /* cbranch_qbbx_eqhihisi4 */
    case 691:  /* cbranch_qbbx_nehiqisi4 */
    case 690:  /* cbranch_qbbx_eqhiqisi4 */
    case 689:  /* cbranch_qbbx_neqisisi4 */
    case 688:  /* cbranch_qbbx_eqqisisi4 */
    case 687:  /* cbranch_qbbx_neqihisi4 */
    case 686:  /* cbranch_qbbx_eqqihisi4 */
    case 685:  /* cbranch_qbbx_neqiqisi4 */
    case 684:  /* cbranch_qbbx_eqqiqisi4 */
    case 683:  /* cbranch_qbbx_nesisihi4 */
    case 682:  /* cbranch_qbbx_eqsisihi4 */
    case 681:  /* cbranch_qbbx_nesihihi4 */
    case 680:  /* cbranch_qbbx_eqsihihi4 */
    case 679:  /* cbranch_qbbx_nesiqihi4 */
    case 678:  /* cbranch_qbbx_eqsiqihi4 */
    case 677:  /* cbranch_qbbx_nehisihi4 */
    case 676:  /* cbranch_qbbx_eqhisihi4 */
    case 675:  /* cbranch_qbbx_nehihihi4 */
    case 674:  /* cbranch_qbbx_eqhihihi4 */
    case 673:  /* cbranch_qbbx_nehiqihi4 */
    case 672:  /* cbranch_qbbx_eqhiqihi4 */
    case 671:  /* cbranch_qbbx_neqisihi4 */
    case 670:  /* cbranch_qbbx_eqqisihi4 */
    case 669:  /* cbranch_qbbx_neqihihi4 */
    case 668:  /* cbranch_qbbx_eqqihihi4 */
    case 667:  /* cbranch_qbbx_neqiqihi4 */
    case 666:  /* cbranch_qbbx_eqqiqihi4 */
    case 665:  /* cbranch_qbbx_nesisiqi4 */
    case 664:  /* cbranch_qbbx_eqsisiqi4 */
    case 663:  /* cbranch_qbbx_nesihiqi4 */
    case 662:  /* cbranch_qbbx_eqsihiqi4 */
    case 661:  /* cbranch_qbbx_nesiqiqi4 */
    case 660:  /* cbranch_qbbx_eqsiqiqi4 */
    case 659:  /* cbranch_qbbx_nehisiqi4 */
    case 658:  /* cbranch_qbbx_eqhisiqi4 */
    case 657:  /* cbranch_qbbx_nehihiqi4 */
    case 656:  /* cbranch_qbbx_eqhihiqi4 */
    case 655:  /* cbranch_qbbx_nehiqiqi4 */
    case 654:  /* cbranch_qbbx_eqhiqiqi4 */
    case 653:  /* cbranch_qbbx_neqisiqi4 */
    case 652:  /* cbranch_qbbx_eqqisiqi4 */
    case 651:  /* cbranch_qbbx_neqihiqi4 */
    case 650:  /* cbranch_qbbx_eqqihiqi4 */
    case 649:  /* cbranch_qbbx_neqiqiqi4 */
    case 648:  /* cbranch_qbbx_eqqiqiqi4 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 647:  /* cbranchsi4_signed */
    case 646:  /* cbranchhi4_signed */
    case 645:  /* cbranchqi4_signed */
    case 644:  /* cbranchsi4_unsigned */
    case 643:  /* cbranchhi4_unsigned */
    case 642:  /* cbranchqi4_unsigned */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 641:  /* *tablejump */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 640:  /* *sibcall_value */
    case 638:  /* *call_value */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 639:  /* *sibcall */
    case 637:  /* *call */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 636:  /* jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 635:  /* indirect_jump */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 722:  /* pru_halt */
    case 721:  /* nop_loop_guard */
    case 720:  /* nop */
    case 719:  /* delay_cycles_1 */
    case 714:  /* pruloop_end */
    case 634:  /* blockage */
    case 633:  /* simple_return */
    case 632:  /* return */
      break;

    case 626:  /* *regio_zext_write_r30si */
    case 625:  /* *regio_zext_write_r30hi */
    case 624:  /* *regio_zext_write_r30qi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      break;

    case 623:  /* *regio_nozext_writesi */
    case 622:  /* *regio_readsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 620:  /* lshr_implsisisi__z_noz0_z1_z2 */
    case 610:  /* lshr_implsihihi__z_noz0_z1_z2 */
    case 604:  /* lshr_implsiqiqi__z_noz0_z1_z2 */
    case 602:  /* lshr_implhisisi__z_noz0_z1_z2 */
    case 594:  /* lshr_implhihihi__z_noz0_z1_z2 */
    case 585:  /* lshr_implhiqiqi__z_noz0_z1_z2 */
    case 583:  /* lshr_implqisisi__z_noz0_z1_z2 */
    case 577:  /* lshr_implqihihi__z_noz0_z1_z2 */
    case 568:  /* lshr_implqiqiqi__z_noz0_z1_z2 */
    case 515:  /* umax_implsisisi__z_noz0_z1_z2 */
    case 510:  /* umin_implsisisi__z_noz0_z1_z2 */
    case 505:  /* xor_implsisisi__z_noz0_z1_z2 */
    case 500:  /* ior_implsisisi__z_noz0_z1_z2 */
    case 495:  /* and_implsisisi__z_noz0_z1_z2 */
    case 461:  /* umax_implsihihi__z_noz0_z1_z2 */
    case 459:  /* umin_implsihihi__z_noz0_z1_z2 */
    case 457:  /* xor_implsihihi__z_noz0_z1_z2 */
    case 455:  /* ior_implsihihi__z_noz0_z1_z2 */
    case 453:  /* and_implsihihi__z_noz0_z1_z2 */
    case 431:  /* umax_implsiqiqi__z_noz0_z1_z2 */
    case 429:  /* umin_implsiqiqi__z_noz0_z1_z2 */
    case 427:  /* xor_implsiqiqi__z_noz0_z1_z2 */
    case 425:  /* ior_implsiqiqi__z_noz0_z1_z2 */
    case 423:  /* and_implsiqiqi__z_noz0_z1_z2 */
    case 421:  /* umax_implhisisi__z_noz0_z1_z2 */
    case 419:  /* umin_implhisisi__z_noz0_z1_z2 */
    case 417:  /* xor_implhisisi__z_noz0_z1_z2 */
    case 415:  /* ior_implhisisi__z_noz0_z1_z2 */
    case 413:  /* and_implhisisi__z_noz0_z1_z2 */
    case 385:  /* umax_implhihihi__z_noz0_z1_z2 */
    case 380:  /* umin_implhihihi__z_noz0_z1_z2 */
    case 375:  /* xor_implhihihi__z_noz0_z1_z2 */
    case 370:  /* ior_implhihihi__z_noz0_z1_z2 */
    case 365:  /* and_implhihihi__z_noz0_z1_z2 */
    case 336:  /* umax_implhiqiqi__z_noz0_z1_z2 */
    case 334:  /* umin_implhiqiqi__z_noz0_z1_z2 */
    case 332:  /* xor_implhiqiqi__z_noz0_z1_z2 */
    case 330:  /* ior_implhiqiqi__z_noz0_z1_z2 */
    case 328:  /* and_implhiqiqi__z_noz0_z1_z2 */
    case 326:  /* umax_implqisisi__z_noz0_z1_z2 */
    case 324:  /* umin_implqisisi__z_noz0_z1_z2 */
    case 322:  /* xor_implqisisi__z_noz0_z1_z2 */
    case 320:  /* ior_implqisisi__z_noz0_z1_z2 */
    case 318:  /* and_implqisisi__z_noz0_z1_z2 */
    case 296:  /* umax_implqihihi__z_noz0_z1_z2 */
    case 294:  /* umin_implqihihi__z_noz0_z1_z2 */
    case 292:  /* xor_implqihihi__z_noz0_z1_z2 */
    case 290:  /* ior_implqihihi__z_noz0_z1_z2 */
    case 288:  /* and_implqihihi__z_noz0_z1_z2 */
    case 255:  /* umax_implqiqiqi__z_noz0_z1_z2 */
    case 250:  /* umin_implqiqiqi__z_noz0_z1_z2 */
    case 245:  /* xor_implqiqiqi__z_noz0_z1_z2 */
    case 240:  /* ior_implqiqiqi__z_noz0_z1_z2 */
    case 235:  /* and_implqiqiqi__z_noz0_z1_z2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 206:  /* one_cmpl_implsisi__z */
    case 205:  /* one_cmpl_implsihi__z */
    case 204:  /* one_cmpl_implsiqi__z */
    case 203:  /* one_cmpl_implhisi__z */
    case 201:  /* one_cmpl_implhihi__z */
    case 200:  /* one_cmpl_implhiqi__z */
    case 199:  /* one_cmpl_implqisi__z */
    case 198:  /* one_cmpl_implqihi__z */
    case 196:  /* one_cmpl_implqiqi__z */
    case 194:  /* neg_implsisi__z */
    case 193:  /* neg_implsihi__z */
    case 192:  /* neg_implsiqi__z */
    case 191:  /* neg_implhisi__z */
    case 189:  /* neg_implhihi__z */
    case 188:  /* neg_implhiqi__z */
    case 187:  /* neg_implqisi__z */
    case 186:  /* neg_implqihi__z */
    case 184:  /* neg_implqiqi__z */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 183:  /* pru_lmbd_implsisisi__z_noz1_z2 */
    case 179:  /* pru_lmbd_implsisihi__z_noz1_z2 */
    case 177:  /* pru_lmbd_implsisiqi__z_noz1_z2 */
    case 166:  /* pru_lmbd_implhihisi__z_noz1_z2 */
    case 164:  /* pru_lmbd_implhihihi__z_noz1_z2 */
    case 160:  /* pru_lmbd_implhihiqi__z_noz1_z2 */
    case 149:  /* pru_lmbd_implqiqisi__z_noz1_z2 */
    case 147:  /* pru_lmbd_implqiqihi__z_noz1_z2 */
    case 145:  /* pru_lmbd_implqiqiqi__z_noz1_z2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      break;

    case 182:  /* pru_lmbd_implsisisi__z_z1_noz2 */
    case 163:  /* pru_lmbd_implhihihi__z_z1_noz2 */
    case 144:  /* pru_lmbd_implqiqiqi__z_z1_noz2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 709:  /* doloop_begin_internalsi */
    case 708:  /* doloop_begin_internalhi */
    case 181:  /* pru_lmbd_implsisisi__noz_z1_z2 */
    case 162:  /* pru_lmbd_implhihihi__noz_z1_z2 */
    case 143:  /* pru_lmbd_implqiqiqi__noz_z1_z2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 180:  /* pru_lmbd_implsisisi__z_z1_z2 */
    case 178:  /* pru_lmbd_implsisihi__z_z1_z2 */
    case 176:  /* pru_lmbd_implsisiqi__z_z1_z2 */
    case 175:  /* pru_lmbd_implsihisi__z_z1_z2 */
    case 174:  /* pru_lmbd_implsihihi__z_z1_z2 */
    case 173:  /* pru_lmbd_implsihiqi__z_z1_z2 */
    case 172:  /* pru_lmbd_implsiqisi__z_z1_z2 */
    case 171:  /* pru_lmbd_implsiqihi__z_z1_z2 */
    case 170:  /* pru_lmbd_implsiqiqi__z_z1_z2 */
    case 169:  /* pru_lmbd_implhisisi__z_z1_z2 */
    case 168:  /* pru_lmbd_implhisihi__z_z1_z2 */
    case 167:  /* pru_lmbd_implhisiqi__z_z1_z2 */
    case 165:  /* pru_lmbd_implhihisi__z_z1_z2 */
    case 161:  /* pru_lmbd_implhihihi__z_z1_z2 */
    case 159:  /* pru_lmbd_implhihiqi__z_z1_z2 */
    case 158:  /* pru_lmbd_implhiqisi__z_z1_z2 */
    case 157:  /* pru_lmbd_implhiqihi__z_z1_z2 */
    case 156:  /* pru_lmbd_implhiqiqi__z_z1_z2 */
    case 155:  /* pru_lmbd_implqisisi__z_z1_z2 */
    case 154:  /* pru_lmbd_implqisihi__z_z1_z2 */
    case 153:  /* pru_lmbd_implqisiqi__z_z1_z2 */
    case 152:  /* pru_lmbd_implqihisi__z_z1_z2 */
    case 151:  /* pru_lmbd_implqihihi__z_z1_z2 */
    case 150:  /* pru_lmbd_implqihiqi__z_z1_z2 */
    case 148:  /* pru_lmbd_implqiqisi__z_z1_z2 */
    case 146:  /* pru_lmbd_implqiqihi__z_z1_z2 */
    case 142:  /* pru_lmbd_implqiqiqi__z_z1_z2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      break;

    case 621:  /* lshr_implsisisi__z_z0_noz1_z2 */
    case 616:  /* lshr_implsisihi__z_z0_noz1_z2 */
    case 614:  /* lshr_implsisiqi__z_z0_noz1_z2 */
    case 597:  /* lshr_implhihisi__z_z0_noz1_z2 */
    case 595:  /* lshr_implhihihi__z_z0_noz1_z2 */
    case 590:  /* lshr_implhihiqi__z_z0_noz1_z2 */
    case 573:  /* lshr_implqiqisi__z_z0_noz1_z2 */
    case 571:  /* lshr_implqiqihi__z_z0_noz1_z2 */
    case 569:  /* lshr_implqiqiqi__z_z0_noz1_z2 */
    case 564:  /* ashl_implsisisi__z_noz1_z2 */
    case 560:  /* ashl_implsisihi__z_noz1_z2 */
    case 558:  /* ashl_implsisiqi__z_noz1_z2 */
    case 544:  /* ashl_implhihisi__z_noz1_z2 */
    case 542:  /* ashl_implhihihi__z_noz1_z2 */
    case 538:  /* ashl_implhihiqi__z_noz1_z2 */
    case 524:  /* ashl_implqiqisi__z_noz1_z2 */
    case 522:  /* ashl_implqiqihi__z_noz1_z2 */
    case 520:  /* ashl_implqiqiqi__z_noz1_z2 */
    case 516:  /* umax_implsisisi__z_z0_noz1_z2 */
    case 511:  /* umin_implsisisi__z_z0_noz1_z2 */
    case 506:  /* xor_implsisisi__z_z0_noz1_z2 */
    case 501:  /* ior_implsisisi__z_z0_noz1_z2 */
    case 496:  /* and_implsisisi__z_z0_noz1_z2 */
    case 491:  /* umax_implsisihi__z_z0_noz1_z2 */
    case 489:  /* umin_implsisihi__z_z0_noz1_z2 */
    case 487:  /* xor_implsisihi__z_z0_noz1_z2 */
    case 485:  /* ior_implsisihi__z_z0_noz1_z2 */
    case 483:  /* and_implsisihi__z_z0_noz1_z2 */
    case 481:  /* umax_implsisiqi__z_z0_noz1_z2 */
    case 479:  /* umin_implsisiqi__z_z0_noz1_z2 */
    case 477:  /* xor_implsisiqi__z_z0_noz1_z2 */
    case 475:  /* ior_implsisiqi__z_z0_noz1_z2 */
    case 473:  /* and_implsisiqi__z_z0_noz1_z2 */
    case 396:  /* umax_implhihisi__z_z0_noz1_z2 */
    case 394:  /* umin_implhihisi__z_z0_noz1_z2 */
    case 392:  /* xor_implhihisi__z_z0_noz1_z2 */
    case 390:  /* ior_implhihisi__z_z0_noz1_z2 */
    case 388:  /* and_implhihisi__z_z0_noz1_z2 */
    case 386:  /* umax_implhihihi__z_z0_noz1_z2 */
    case 381:  /* umin_implhihihi__z_z0_noz1_z2 */
    case 376:  /* xor_implhihihi__z_z0_noz1_z2 */
    case 371:  /* ior_implhihihi__z_z0_noz1_z2 */
    case 366:  /* and_implhihihi__z_z0_noz1_z2 */
    case 361:  /* umax_implhihiqi__z_z0_noz1_z2 */
    case 359:  /* umin_implhihiqi__z_z0_noz1_z2 */
    case 357:  /* xor_implhihiqi__z_z0_noz1_z2 */
    case 355:  /* ior_implhihiqi__z_z0_noz1_z2 */
    case 353:  /* and_implhihiqi__z_z0_noz1_z2 */
    case 276:  /* umax_implqiqisi__z_z0_noz1_z2 */
    case 274:  /* umin_implqiqisi__z_z0_noz1_z2 */
    case 272:  /* xor_implqiqisi__z_z0_noz1_z2 */
    case 270:  /* ior_implqiqisi__z_z0_noz1_z2 */
    case 268:  /* and_implqiqisi__z_z0_noz1_z2 */
    case 266:  /* umax_implqiqihi__z_z0_noz1_z2 */
    case 264:  /* umin_implqiqihi__z_z0_noz1_z2 */
    case 262:  /* xor_implqiqihi__z_z0_noz1_z2 */
    case 260:  /* ior_implqiqihi__z_z0_noz1_z2 */
    case 258:  /* and_implqiqihi__z_z0_noz1_z2 */
    case 256:  /* umax_implqiqiqi__z_z0_noz1_z2 */
    case 251:  /* umin_implqiqiqi__z_z0_noz1_z2 */
    case 246:  /* xor_implqiqiqi__z_z0_noz1_z2 */
    case 241:  /* ior_implqiqiqi__z_z0_noz1_z2 */
    case 236:  /* and_implqiqiqi__z_z0_noz1_z2 */
    case 141:  /* sub_implsisisi__z_noz1_z2 */
    case 137:  /* sub_implsisihi__z_noz1_z2 */
    case 135:  /* sub_implsisiqi__z_noz1_z2 */
    case 121:  /* sub_implhihisi__z_noz1_z2 */
    case 119:  /* sub_implhihihi__z_noz1_z2 */
    case 115:  /* sub_implhihiqi__z_noz1_z2 */
    case 101:  /* sub_implqiqisi__z_noz1_z2 */
    case 99:  /* sub_implqiqihi__z_noz1_z2 */
    case 97:  /* sub_implqiqiqi__z_noz1_z2 */
    case 93:  /* add_implsisisi__z_noz1_z2 */
    case 89:  /* add_implsisihi__z_noz1_z2 */
    case 87:  /* add_implsisiqi__z_noz1_z2 */
    case 73:  /* add_implhihisi__z_noz1_z2 */
    case 71:  /* add_implhihihi__z_noz1_z2 */
    case 67:  /* add_implhihiqi__z_noz1_z2 */
    case 53:  /* add_implqiqisi__z_noz1_z2 */
    case 51:  /* add_implqiqihi__z_noz1_z2 */
    case 49:  /* add_implqiqiqi__z_noz1_z2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 618:  /* lshr_implsisisi__z_z0_z1_noz2 */
    case 612:  /* lshr_implsihisi__z_z0_z1_noz2 */
    case 607:  /* lshr_implsiqisi__z_z0_z1_noz2 */
    case 600:  /* lshr_implhisihi__z_z0_z1_noz2 */
    case 592:  /* lshr_implhihihi__z_z0_z1_noz2 */
    case 587:  /* lshr_implhiqihi__z_z0_z1_noz2 */
    case 580:  /* lshr_implqisiqi__z_z0_z1_noz2 */
    case 575:  /* lshr_implqihiqi__z_z0_z1_noz2 */
    case 566:  /* lshr_implqiqiqi__z_z0_z1_noz2 */
    case 562:  /* ashl_implsisisi__z_z1_noz2 */
    case 556:  /* ashl_implsihisi__z_z1_noz2 */
    case 552:  /* ashl_implsiqisi__z_z1_noz2 */
    case 547:  /* ashl_implhisihi__z_z1_noz2 */
    case 540:  /* ashl_implhihihi__z_z1_noz2 */
    case 535:  /* ashl_implhiqihi__z_z1_noz2 */
    case 530:  /* ashl_implqisiqi__z_z1_noz2 */
    case 526:  /* ashl_implqihiqi__z_z1_noz2 */
    case 518:  /* ashl_implqiqiqi__z_z1_noz2 */
    case 513:  /* umax_implsisisi__z_z0_z1_noz2 */
    case 508:  /* umin_implsisisi__z_z0_z1_noz2 */
    case 503:  /* xor_implsisisi__z_z0_z1_noz2 */
    case 498:  /* ior_implsisisi__z_z0_z1_noz2 */
    case 493:  /* and_implsisisi__z_z0_z1_noz2 */
    case 471:  /* umax_implsihisi__z_z0_z1_noz2 */
    case 469:  /* umin_implsihisi__z_z0_z1_noz2 */
    case 467:  /* xor_implsihisi__z_z0_z1_noz2 */
    case 465:  /* ior_implsihisi__z_z0_z1_noz2 */
    case 463:  /* and_implsihisi__z_z0_z1_noz2 */
    case 446:  /* umax_implsiqisi__z_z0_z1_noz2 */
    case 444:  /* umin_implsiqisi__z_z0_z1_noz2 */
    case 442:  /* xor_implsiqisi__z_z0_z1_noz2 */
    case 440:  /* ior_implsiqisi__z_z0_z1_noz2 */
    case 438:  /* and_implsiqisi__z_z0_z1_noz2 */
    case 411:  /* umax_implhisihi__z_z0_z1_noz2 */
    case 409:  /* umin_implhisihi__z_z0_z1_noz2 */
    case 407:  /* xor_implhisihi__z_z0_z1_noz2 */
    case 405:  /* ior_implhisihi__z_z0_z1_noz2 */
    case 403:  /* and_implhisihi__z_z0_z1_noz2 */
    case 383:  /* umax_implhihihi__z_z0_z1_noz2 */
    case 378:  /* umin_implhihihi__z_z0_z1_noz2 */
    case 373:  /* xor_implhihihi__z_z0_z1_noz2 */
    case 368:  /* ior_implhihihi__z_z0_z1_noz2 */
    case 363:  /* and_implhihihi__z_z0_z1_noz2 */
    case 346:  /* umax_implhiqihi__z_z0_z1_noz2 */
    case 344:  /* umin_implhiqihi__z_z0_z1_noz2 */
    case 342:  /* xor_implhiqihi__z_z0_z1_noz2 */
    case 340:  /* ior_implhiqihi__z_z0_z1_noz2 */
    case 338:  /* and_implhiqihi__z_z0_z1_noz2 */
    case 311:  /* umax_implqisiqi__z_z0_z1_noz2 */
    case 309:  /* umin_implqisiqi__z_z0_z1_noz2 */
    case 307:  /* xor_implqisiqi__z_z0_z1_noz2 */
    case 305:  /* ior_implqisiqi__z_z0_z1_noz2 */
    case 303:  /* and_implqisiqi__z_z0_z1_noz2 */
    case 286:  /* umax_implqihiqi__z_z0_z1_noz2 */
    case 284:  /* umin_implqihiqi__z_z0_z1_noz2 */
    case 282:  /* xor_implqihiqi__z_z0_z1_noz2 */
    case 280:  /* ior_implqihiqi__z_z0_z1_noz2 */
    case 278:  /* and_implqihiqi__z_z0_z1_noz2 */
    case 253:  /* umax_implqiqiqi__z_z0_z1_noz2 */
    case 248:  /* umin_implqiqiqi__z_z0_z1_noz2 */
    case 243:  /* xor_implqiqiqi__z_z0_z1_noz2 */
    case 238:  /* ior_implqiqiqi__z_z0_z1_noz2 */
    case 233:  /* and_implqiqiqi__z_z0_z1_noz2 */
    case 230:  /* setbit_sisi__z */
    case 229:  /* setbit_sihi__z */
    case 228:  /* setbit_siqi__z */
    case 227:  /* setbit_hisi__z */
    case 225:  /* setbit_hihi__z */
    case 224:  /* setbit_hiqi__z */
    case 223:  /* setbit_qisi__z */
    case 222:  /* setbit_qihi__z */
    case 220:  /* setbit_qiqi__z */
    case 218:  /* clearbit_sisi__z */
    case 217:  /* clearbit_sihi__z */
    case 216:  /* clearbit_siqi__z */
    case 215:  /* clearbit_hisi__z */
    case 213:  /* clearbit_hihi__z */
    case 212:  /* clearbit_hiqi__z */
    case 211:  /* clearbit_qisi__z */
    case 210:  /* clearbit_qihi__z */
    case 208:  /* clearbit_qiqi__z */
    case 139:  /* sub_implsisisi__z_z1_noz2 */
    case 133:  /* sub_implsihisi__z_z1_noz2 */
    case 129:  /* sub_implsiqisi__z_z1_noz2 */
    case 124:  /* sub_implhisihi__z_z1_noz2 */
    case 117:  /* sub_implhihihi__z_z1_noz2 */
    case 112:  /* sub_implhiqihi__z_z1_noz2 */
    case 107:  /* sub_implqisiqi__z_z1_noz2 */
    case 103:  /* sub_implqihiqi__z_z1_noz2 */
    case 95:  /* sub_implqiqiqi__z_z1_noz2 */
    case 91:  /* add_implsisisi__z_z1_noz2 */
    case 85:  /* add_implsihisi__z_z1_noz2 */
    case 81:  /* add_implsiqisi__z_z1_noz2 */
    case 76:  /* add_implhisihi__z_z1_noz2 */
    case 69:  /* add_implhihihi__z_z1_noz2 */
    case 64:  /* add_implhiqihi__z_z1_noz2 */
    case 59:  /* add_implqisiqi__z_z1_noz2 */
    case 55:  /* add_implqihiqi__z_z1_noz2 */
    case 47:  /* add_implqiqiqi__z_z1_noz2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 617:  /* lshr_implsisisi__z_z0_z1_z2 */
    case 615:  /* lshr_implsisihi__z_z0_z1_z2 */
    case 613:  /* lshr_implsisiqi__z_z0_z1_z2 */
    case 611:  /* lshr_implsihisi__z_z0_z1_z2 */
    case 609:  /* lshr_implsihihi__z_z0_z1_z2 */
    case 608:  /* lshr_implsihiqi__z_z0_z1_z2 */
    case 606:  /* lshr_implsiqisi__z_z0_z1_z2 */
    case 605:  /* lshr_implsiqihi__z_z0_z1_z2 */
    case 603:  /* lshr_implsiqiqi__z_z0_z1_z2 */
    case 601:  /* lshr_implhisisi__z_z0_z1_z2 */
    case 599:  /* lshr_implhisihi__z_z0_z1_z2 */
    case 598:  /* lshr_implhisiqi__z_z0_z1_z2 */
    case 596:  /* lshr_implhihisi__z_z0_z1_z2 */
    case 591:  /* lshr_implhihihi__z_z0_z1_z2 */
    case 589:  /* lshr_implhihiqi__z_z0_z1_z2 */
    case 588:  /* lshr_implhiqisi__z_z0_z1_z2 */
    case 586:  /* lshr_implhiqihi__z_z0_z1_z2 */
    case 584:  /* lshr_implhiqiqi__z_z0_z1_z2 */
    case 582:  /* lshr_implqisisi__z_z0_z1_z2 */
    case 581:  /* lshr_implqisihi__z_z0_z1_z2 */
    case 579:  /* lshr_implqisiqi__z_z0_z1_z2 */
    case 578:  /* lshr_implqihisi__z_z0_z1_z2 */
    case 576:  /* lshr_implqihihi__z_z0_z1_z2 */
    case 574:  /* lshr_implqihiqi__z_z0_z1_z2 */
    case 572:  /* lshr_implqiqisi__z_z0_z1_z2 */
    case 570:  /* lshr_implqiqihi__z_z0_z1_z2 */
    case 565:  /* lshr_implqiqiqi__z_z0_z1_z2 */
    case 561:  /* ashl_implsisisi__z_z1_z2 */
    case 559:  /* ashl_implsisihi__z_z1_z2 */
    case 557:  /* ashl_implsisiqi__z_z1_z2 */
    case 555:  /* ashl_implsihisi__z_z1_z2 */
    case 554:  /* ashl_implsihihi__z_z1_z2 */
    case 553:  /* ashl_implsihiqi__z_z1_z2 */
    case 551:  /* ashl_implsiqisi__z_z1_z2 */
    case 550:  /* ashl_implsiqihi__z_z1_z2 */
    case 549:  /* ashl_implsiqiqi__z_z1_z2 */
    case 548:  /* ashl_implhisisi__z_z1_z2 */
    case 546:  /* ashl_implhisihi__z_z1_z2 */
    case 545:  /* ashl_implhisiqi__z_z1_z2 */
    case 543:  /* ashl_implhihisi__z_z1_z2 */
    case 539:  /* ashl_implhihihi__z_z1_z2 */
    case 537:  /* ashl_implhihiqi__z_z1_z2 */
    case 536:  /* ashl_implhiqisi__z_z1_z2 */
    case 534:  /* ashl_implhiqihi__z_z1_z2 */
    case 533:  /* ashl_implhiqiqi__z_z1_z2 */
    case 532:  /* ashl_implqisisi__z_z1_z2 */
    case 531:  /* ashl_implqisihi__z_z1_z2 */
    case 529:  /* ashl_implqisiqi__z_z1_z2 */
    case 528:  /* ashl_implqihisi__z_z1_z2 */
    case 527:  /* ashl_implqihihi__z_z1_z2 */
    case 525:  /* ashl_implqihiqi__z_z1_z2 */
    case 523:  /* ashl_implqiqisi__z_z1_z2 */
    case 521:  /* ashl_implqiqihi__z_z1_z2 */
    case 517:  /* ashl_implqiqiqi__z_z1_z2 */
    case 512:  /* umax_implsisisi__z_z0_z1_z2 */
    case 507:  /* umin_implsisisi__z_z0_z1_z2 */
    case 502:  /* xor_implsisisi__z_z0_z1_z2 */
    case 497:  /* ior_implsisisi__z_z0_z1_z2 */
    case 492:  /* and_implsisisi__z_z0_z1_z2 */
    case 490:  /* umax_implsisihi__z_z0_z1_z2 */
    case 488:  /* umin_implsisihi__z_z0_z1_z2 */
    case 486:  /* xor_implsisihi__z_z0_z1_z2 */
    case 484:  /* ior_implsisihi__z_z0_z1_z2 */
    case 482:  /* and_implsisihi__z_z0_z1_z2 */
    case 480:  /* umax_implsisiqi__z_z0_z1_z2 */
    case 478:  /* umin_implsisiqi__z_z0_z1_z2 */
    case 476:  /* xor_implsisiqi__z_z0_z1_z2 */
    case 474:  /* ior_implsisiqi__z_z0_z1_z2 */
    case 472:  /* and_implsisiqi__z_z0_z1_z2 */
    case 470:  /* umax_implsihisi__z_z0_z1_z2 */
    case 468:  /* umin_implsihisi__z_z0_z1_z2 */
    case 466:  /* xor_implsihisi__z_z0_z1_z2 */
    case 464:  /* ior_implsihisi__z_z0_z1_z2 */
    case 462:  /* and_implsihisi__z_z0_z1_z2 */
    case 460:  /* umax_implsihihi__z_z0_z1_z2 */
    case 458:  /* umin_implsihihi__z_z0_z1_z2 */
    case 456:  /* xor_implsihihi__z_z0_z1_z2 */
    case 454:  /* ior_implsihihi__z_z0_z1_z2 */
    case 452:  /* and_implsihihi__z_z0_z1_z2 */
    case 451:  /* umax_implsihiqi__z_z0_z1_z2 */
    case 450:  /* umin_implsihiqi__z_z0_z1_z2 */
    case 449:  /* xor_implsihiqi__z_z0_z1_z2 */
    case 448:  /* ior_implsihiqi__z_z0_z1_z2 */
    case 447:  /* and_implsihiqi__z_z0_z1_z2 */
    case 445:  /* umax_implsiqisi__z_z0_z1_z2 */
    case 443:  /* umin_implsiqisi__z_z0_z1_z2 */
    case 441:  /* xor_implsiqisi__z_z0_z1_z2 */
    case 439:  /* ior_implsiqisi__z_z0_z1_z2 */
    case 437:  /* and_implsiqisi__z_z0_z1_z2 */
    case 436:  /* umax_implsiqihi__z_z0_z1_z2 */
    case 435:  /* umin_implsiqihi__z_z0_z1_z2 */
    case 434:  /* xor_implsiqihi__z_z0_z1_z2 */
    case 433:  /* ior_implsiqihi__z_z0_z1_z2 */
    case 432:  /* and_implsiqihi__z_z0_z1_z2 */
    case 430:  /* umax_implsiqiqi__z_z0_z1_z2 */
    case 428:  /* umin_implsiqiqi__z_z0_z1_z2 */
    case 426:  /* xor_implsiqiqi__z_z0_z1_z2 */
    case 424:  /* ior_implsiqiqi__z_z0_z1_z2 */
    case 422:  /* and_implsiqiqi__z_z0_z1_z2 */
    case 420:  /* umax_implhisisi__z_z0_z1_z2 */
    case 418:  /* umin_implhisisi__z_z0_z1_z2 */
    case 416:  /* xor_implhisisi__z_z0_z1_z2 */
    case 414:  /* ior_implhisisi__z_z0_z1_z2 */
    case 412:  /* and_implhisisi__z_z0_z1_z2 */
    case 410:  /* umax_implhisihi__z_z0_z1_z2 */
    case 408:  /* umin_implhisihi__z_z0_z1_z2 */
    case 406:  /* xor_implhisihi__z_z0_z1_z2 */
    case 404:  /* ior_implhisihi__z_z0_z1_z2 */
    case 402:  /* and_implhisihi__z_z0_z1_z2 */
    case 401:  /* umax_implhisiqi__z_z0_z1_z2 */
    case 400:  /* umin_implhisiqi__z_z0_z1_z2 */
    case 399:  /* xor_implhisiqi__z_z0_z1_z2 */
    case 398:  /* ior_implhisiqi__z_z0_z1_z2 */
    case 397:  /* and_implhisiqi__z_z0_z1_z2 */
    case 395:  /* umax_implhihisi__z_z0_z1_z2 */
    case 393:  /* umin_implhihisi__z_z0_z1_z2 */
    case 391:  /* xor_implhihisi__z_z0_z1_z2 */
    case 389:  /* ior_implhihisi__z_z0_z1_z2 */
    case 387:  /* and_implhihisi__z_z0_z1_z2 */
    case 382:  /* umax_implhihihi__z_z0_z1_z2 */
    case 377:  /* umin_implhihihi__z_z0_z1_z2 */
    case 372:  /* xor_implhihihi__z_z0_z1_z2 */
    case 367:  /* ior_implhihihi__z_z0_z1_z2 */
    case 362:  /* and_implhihihi__z_z0_z1_z2 */
    case 360:  /* umax_implhihiqi__z_z0_z1_z2 */
    case 358:  /* umin_implhihiqi__z_z0_z1_z2 */
    case 356:  /* xor_implhihiqi__z_z0_z1_z2 */
    case 354:  /* ior_implhihiqi__z_z0_z1_z2 */
    case 352:  /* and_implhihiqi__z_z0_z1_z2 */
    case 351:  /* umax_implhiqisi__z_z0_z1_z2 */
    case 350:  /* umin_implhiqisi__z_z0_z1_z2 */
    case 349:  /* xor_implhiqisi__z_z0_z1_z2 */
    case 348:  /* ior_implhiqisi__z_z0_z1_z2 */
    case 347:  /* and_implhiqisi__z_z0_z1_z2 */
    case 345:  /* umax_implhiqihi__z_z0_z1_z2 */
    case 343:  /* umin_implhiqihi__z_z0_z1_z2 */
    case 341:  /* xor_implhiqihi__z_z0_z1_z2 */
    case 339:  /* ior_implhiqihi__z_z0_z1_z2 */
    case 337:  /* and_implhiqihi__z_z0_z1_z2 */
    case 335:  /* umax_implhiqiqi__z_z0_z1_z2 */
    case 333:  /* umin_implhiqiqi__z_z0_z1_z2 */
    case 331:  /* xor_implhiqiqi__z_z0_z1_z2 */
    case 329:  /* ior_implhiqiqi__z_z0_z1_z2 */
    case 327:  /* and_implhiqiqi__z_z0_z1_z2 */
    case 325:  /* umax_implqisisi__z_z0_z1_z2 */
    case 323:  /* umin_implqisisi__z_z0_z1_z2 */
    case 321:  /* xor_implqisisi__z_z0_z1_z2 */
    case 319:  /* ior_implqisisi__z_z0_z1_z2 */
    case 317:  /* and_implqisisi__z_z0_z1_z2 */
    case 316:  /* umax_implqisihi__z_z0_z1_z2 */
    case 315:  /* umin_implqisihi__z_z0_z1_z2 */
    case 314:  /* xor_implqisihi__z_z0_z1_z2 */
    case 313:  /* ior_implqisihi__z_z0_z1_z2 */
    case 312:  /* and_implqisihi__z_z0_z1_z2 */
    case 310:  /* umax_implqisiqi__z_z0_z1_z2 */
    case 308:  /* umin_implqisiqi__z_z0_z1_z2 */
    case 306:  /* xor_implqisiqi__z_z0_z1_z2 */
    case 304:  /* ior_implqisiqi__z_z0_z1_z2 */
    case 302:  /* and_implqisiqi__z_z0_z1_z2 */
    case 301:  /* umax_implqihisi__z_z0_z1_z2 */
    case 300:  /* umin_implqihisi__z_z0_z1_z2 */
    case 299:  /* xor_implqihisi__z_z0_z1_z2 */
    case 298:  /* ior_implqihisi__z_z0_z1_z2 */
    case 297:  /* and_implqihisi__z_z0_z1_z2 */
    case 295:  /* umax_implqihihi__z_z0_z1_z2 */
    case 293:  /* umin_implqihihi__z_z0_z1_z2 */
    case 291:  /* xor_implqihihi__z_z0_z1_z2 */
    case 289:  /* ior_implqihihi__z_z0_z1_z2 */
    case 287:  /* and_implqihihi__z_z0_z1_z2 */
    case 285:  /* umax_implqihiqi__z_z0_z1_z2 */
    case 283:  /* umin_implqihiqi__z_z0_z1_z2 */
    case 281:  /* xor_implqihiqi__z_z0_z1_z2 */
    case 279:  /* ior_implqihiqi__z_z0_z1_z2 */
    case 277:  /* and_implqihiqi__z_z0_z1_z2 */
    case 275:  /* umax_implqiqisi__z_z0_z1_z2 */
    case 273:  /* umin_implqiqisi__z_z0_z1_z2 */
    case 271:  /* xor_implqiqisi__z_z0_z1_z2 */
    case 269:  /* ior_implqiqisi__z_z0_z1_z2 */
    case 267:  /* and_implqiqisi__z_z0_z1_z2 */
    case 265:  /* umax_implqiqihi__z_z0_z1_z2 */
    case 263:  /* umin_implqiqihi__z_z0_z1_z2 */
    case 261:  /* xor_implqiqihi__z_z0_z1_z2 */
    case 259:  /* ior_implqiqihi__z_z0_z1_z2 */
    case 257:  /* and_implqiqihi__z_z0_z1_z2 */
    case 252:  /* umax_implqiqiqi__z_z0_z1_z2 */
    case 247:  /* umin_implqiqiqi__z_z0_z1_z2 */
    case 242:  /* xor_implqiqiqi__z_z0_z1_z2 */
    case 237:  /* ior_implqiqiqi__z_z0_z1_z2 */
    case 232:  /* and_implqiqiqi__z_z0_z1_z2 */
    case 138:  /* sub_implsisisi__z_z1_z2 */
    case 136:  /* sub_implsisihi__z_z1_z2 */
    case 134:  /* sub_implsisiqi__z_z1_z2 */
    case 132:  /* sub_implsihisi__z_z1_z2 */
    case 131:  /* sub_implsihihi__z_z1_z2 */
    case 130:  /* sub_implsihiqi__z_z1_z2 */
    case 128:  /* sub_implsiqisi__z_z1_z2 */
    case 127:  /* sub_implsiqihi__z_z1_z2 */
    case 126:  /* sub_implsiqiqi__z_z1_z2 */
    case 125:  /* sub_implhisisi__z_z1_z2 */
    case 123:  /* sub_implhisihi__z_z1_z2 */
    case 122:  /* sub_implhisiqi__z_z1_z2 */
    case 120:  /* sub_implhihisi__z_z1_z2 */
    case 116:  /* sub_implhihihi__z_z1_z2 */
    case 114:  /* sub_implhihiqi__z_z1_z2 */
    case 113:  /* sub_implhiqisi__z_z1_z2 */
    case 111:  /* sub_implhiqihi__z_z1_z2 */
    case 110:  /* sub_implhiqiqi__z_z1_z2 */
    case 109:  /* sub_implqisisi__z_z1_z2 */
    case 108:  /* sub_implqisihi__z_z1_z2 */
    case 106:  /* sub_implqisiqi__z_z1_z2 */
    case 105:  /* sub_implqihisi__z_z1_z2 */
    case 104:  /* sub_implqihihi__z_z1_z2 */
    case 102:  /* sub_implqihiqi__z_z1_z2 */
    case 100:  /* sub_implqiqisi__z_z1_z2 */
    case 98:  /* sub_implqiqihi__z_z1_z2 */
    case 94:  /* sub_implqiqiqi__z_z1_z2 */
    case 90:  /* add_implsisisi__z_z1_z2 */
    case 88:  /* add_implsisihi__z_z1_z2 */
    case 86:  /* add_implsisiqi__z_z1_z2 */
    case 84:  /* add_implsihisi__z_z1_z2 */
    case 83:  /* add_implsihihi__z_z1_z2 */
    case 82:  /* add_implsihiqi__z_z1_z2 */
    case 80:  /* add_implsiqisi__z_z1_z2 */
    case 79:  /* add_implsiqihi__z_z1_z2 */
    case 78:  /* add_implsiqiqi__z_z1_z2 */
    case 77:  /* add_implhisisi__z_z1_z2 */
    case 75:  /* add_implhisihi__z_z1_z2 */
    case 74:  /* add_implhisiqi__z_z1_z2 */
    case 72:  /* add_implhihisi__z_z1_z2 */
    case 68:  /* add_implhihihi__z_z1_z2 */
    case 66:  /* add_implhihiqi__z_z1_z2 */
    case 65:  /* add_implhiqisi__z_z1_z2 */
    case 63:  /* add_implhiqihi__z_z1_z2 */
    case 62:  /* add_implhiqiqi__z_z1_z2 */
    case 61:  /* add_implqisisi__z_z1_z2 */
    case 60:  /* add_implqisihi__z_z1_z2 */
    case 58:  /* add_implqisiqi__z_z1_z2 */
    case 57:  /* add_implqihisi__z_z1_z2 */
    case 56:  /* add_implqihihi__z_z1_z2 */
    case 54:  /* add_implqihiqi__z_z1_z2 */
    case 52:  /* add_implqiqisi__z_z1_z2 */
    case 50:  /* add_implqiqihi__z_z1_z2 */
    case 46:  /* add_implqiqiqi__z_z1_z2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 631:  /* mulsi3 */
    case 629:  /* pru_xordi3 */
    case 628:  /* pru_iordi3 */
    case 627:  /* pru_anddi3 */
    case 619:  /* lshr_implsisisi__noz_z0_z1_z2 */
    case 593:  /* lshr_implhihihi__noz_z0_z1_z2 */
    case 567:  /* lshr_implqiqiqi__noz_z0_z1_z2 */
    case 563:  /* ashl_implsisisi__noz_z1_z2 */
    case 541:  /* ashl_implhihihi__noz_z1_z2 */
    case 519:  /* ashl_implqiqiqi__noz_z1_z2 */
    case 514:  /* umax_implsisisi__noz_z0_z1_z2 */
    case 509:  /* umin_implsisisi__noz_z0_z1_z2 */
    case 504:  /* xor_implsisisi__noz_z0_z1_z2 */
    case 499:  /* ior_implsisisi__noz_z0_z1_z2 */
    case 494:  /* and_implsisisi__noz_z0_z1_z2 */
    case 384:  /* umax_implhihihi__noz_z0_z1_z2 */
    case 379:  /* umin_implhihihi__noz_z0_z1_z2 */
    case 374:  /* xor_implhihihi__noz_z0_z1_z2 */
    case 369:  /* ior_implhihihi__noz_z0_z1_z2 */
    case 364:  /* and_implhihihi__noz_z0_z1_z2 */
    case 254:  /* umax_implqiqiqi__noz_z0_z1_z2 */
    case 249:  /* umin_implqiqiqi__noz_z0_z1_z2 */
    case 244:  /* xor_implqiqiqi__noz_z0_z1_z2 */
    case 239:  /* ior_implqiqiqi__noz_z0_z1_z2 */
    case 234:  /* and_implqiqiqi__noz_z0_z1_z2 */
    case 231:  /* setbit_sisi__noz */
    case 226:  /* setbit_hihi__noz */
    case 221:  /* setbit_qiqi__noz */
    case 219:  /* clearbit_sisi__noz */
    case 214:  /* clearbit_hihi__noz */
    case 209:  /* clearbit_qiqi__noz */
    case 140:  /* sub_implsisisi__noz_z1_z2 */
    case 118:  /* sub_implhihihi__noz_z1_z2 */
    case 96:  /* sub_implqiqiqi__noz_z1_z2 */
    case 92:  /* add_implsisisi__noz_z1_z2 */
    case 70:  /* add_implhihihi__noz_z1_z2 */
    case 48:  /* add_implqiqiqi__noz_z1_z2 */
    case 45:  /* ashrsi3_single */
    case 44:  /* ashrhi3_single */
    case 43:  /* ashrqi3_single */
    case 42:  /* pru_and_zerobytesdi */
    case 41:  /* pru_and_zerobytessi */
    case 40:  /* pru_and_zerobyteshi */
    case 39:  /* pru_ior_fillbytesdi */
    case 38:  /* pru_ior_fillbytessi */
    case 37:  /* pru_ior_fillbyteshi */
    case 36:  /* subdi3 */
    case 35:  /* adddi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 630:  /* one_cmpldi2 */
    case 207:  /* one_cmpl_implsisi__noz */
    case 202:  /* one_cmpl_implhihi__noz */
    case 197:  /* one_cmpl_implqiqi__noz */
    case 195:  /* neg_implsisi__noz */
    case 190:  /* neg_implhihi__noz */
    case 185:  /* neg_implqiqi__noz */
    case 34:  /* zero_extendsidi2 */
    case 33:  /* zero_extendhidi2 */
    case 32:  /* zero_extendqidi2 */
    case 31:  /* *zero_extendsisi2 */
    case 30:  /* *zero_extendhisi2 */
    case 29:  /* *zero_extendqisi2 */
    case 28:  /* *zero_extendsihi2 */
    case 27:  /* *zero_extendhihi2 */
    case 26:  /* *zero_extendqihi2 */
    case 25:  /* *zero_extendsiqi2 */
    case 24:  /* *zero_extendhiqi2 */
    case 23:  /* *zero_extendqiqi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 22:  /* *pru_store_multiple */
    case 21:  /* *pru_load_multiple */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 20:  /* movudq */
    case 19:  /* movdq */
    case 18:  /* movdd */
    case 17:  /* movdf */
    case 16:  /* movdi */
    case 15:  /* prumovuha */
    case 14:  /* prumovha */
    case 13:  /* prumovuhq */
    case 12:  /* prumovhq */
    case 11:  /* prumovhi */
    case 10:  /* prumovuqq */
    case 9:  /* prumovqq */
    case 8:  /* prumovqi */
    case 7:  /* prumovsd */
    case 6:  /* prumovsf */
    case 5:  /* prumovusa */
    case 4:  /* prumovsa */
    case 3:  /* prumovusq */
    case 2:  /* prumovsq */
    case 1:  /* prumovsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    }
}
